Program TalkIt;
{*---------------------------------------------------------------------*}
{* TalkIt                                                              *}
{* Talk Thru quick hack program                                        *}
{*                                                                     *}
{*         Copyright (c) 2000 LU7DID Only for radioamateur uses        *}
(*     Excerpts from this code must be properly credited whenever used *)
(*                                                                     *)
(*                        Free for radioamateur uses                   *)
(*                      Commercial usage is prohibited                 *)
(*                                                                     *)
{*---------------------------------------------------------------------*}
{$R-}
{$APPTYPE CONSOLE}
{$H+}
{$M 512000,7000000}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ScktComp, ReqLib32 , INIFiles, Menus, ExtCtrls, Gauges, Spin,
  ShellAPI, HexStr, ComCtrls,Log,WinTypes,MSXML2_TLB,ActiveX,ComObj,
  mSpeech,WSocket;


(*-->> Constants <<---------------------------------------------------------*)
(* Main AIML Object                                                         *)
(*--------------------------------------------------------------------------*)
  Const
                                            {*------------------------------*}
                                            {*  Program Related Constants   *}
                                            {*------------------------------*}
    CR          =       Chr($0D);           {*Commonly Used ASCII constants *}
    LF          =       Chr($0A);           {*                              *}
    ESC         =       Chr($1B);           {*                              *}
    CRLF        =       CR+LF;              {*                              *}
    NUL         =       Chr($00);           {*                              *}
                                            {*------------------------------*}
    PROGRAMNAME =       'TalkIt';
    VERSION     =       '1.00';
    PROGRAMBUILD=       '02';
    AUTHOR      =       'Pedro E. Colla (c) LU7DID 2001';
    BUFFER_LENGTH=      16384;

  Var
    szBuffer     :      String;             {*Output Buffer                 *}
    hStream      :      TMemoryStream;      {*Memory Stream (std Input Load)*}
    i            :      Integer;            {*General Purpose Counter       *}
    hSpeech      :      TMSpeech;           {*Speech Processor Output       *}
    wVoice       :      Word;               {*Voice Processor               *}
    fVoice       :      Boolean;            {*Voice enabled                 *}
    fQuiet       :      Boolean;            {*No Output                     *}
    fTrace       :      Boolean;
    pBuffer      :      Array[0..2] of Char;
    iLen         :      Integer;
    fASCII       :      Boolean;

{*-------------------------------------------------------------------------*}
{* TerminateBot                                                            *}
{*-------------------------------------------------------------------------*}
Procedure TerminateProgram;

begin { TerminateProgram }

 WriteLn;
 WriteLn('TalkIt(000): Termination requested');

 If Assigned(hSpeech) then begin
    hSpeech.Destroy;
 end; {endif}

 WriteLn('TalkIt(000): Termination clean-up completed');
 Halt;

end; { TerminateProgram }
{*-------------------------------------------------------------------------*}
{* ConProc                                                                 *}
{* Console Event Handler, traps all interruptions while waiting for an     *}
{* entry from the user (specially to terminate clean)                      *}
{*-------------------------------------------------------------------------*}
function ConProc(CtrlType : DWord) : Bool; stdcall; far;
var
   fClose       :       Boolean;
begin

 case CtrlType of
   CTRL_C_EVENT        ,
   CTRL_BREAK_EVENT    ,
   CTRL_CLOSE_EVENT    ,
   CTRL_LOGOFF_EVENT   ,
   CTRL_SHUTDOWN_EVENT : fClose := TRUE;
  else
   fClose := FALSE;
 end;

 If fClose = FALSE then begin
    Result := True;
    Exit;
 end; {endif}

 TerminateProgram;
 Result := TRUE;

end;
{*-------------------------------------------------------------------------*}
{* Main Program                                                            *}
{* Console loop to serve as a test bed for the TBot/TAiml components       *}
{*-------------------------------------------------------------------------*}
Begin

    szBuffer     := '';
    i            := 1;
    hStream      := TMemoryStream.Create;
    wVoice       := 1;
    fVoice       := FALSE;
    fQuiet       := FALSE;
    fTrace       := FALSE;
    fASCII       := FALSE;

    {*--------------------------------------------*}
    {* Process Arguments                          *}
    {*--------------------------------------------*}
    While ParamCount >= i do begin

      If (UpCaseStr(ParamStr(i)) = '-V') then begin
         inc(i);
         If IsNumeric(ParamStr(i)) = TRUE then begin
            wVoice := StrToInt(ParamStr(i));
            If wVoice > 0 then begin
               fVoice := TRUE;
            end; {endif}
         end else begin
            fVoice := TRUE;
            wVoice := 1;
         end; {endif}
      end; {endif}

      If UpCaseStr(ParamStr(i)) = '-Q' then begin
         fQuiet := TRUE;
      end; {endif}

      If UpCaseStr(ParamStr(i)) = '-T' then begin
         fTrace := TRUE;
      end; {endif}

      If UpCaseStr(ParamStr(i)) = '-A' then begin
         fASCII := TRUE;
      end; {endif}

      If (UpCaseStr(ParamStr(i)) = '-?') or
         (UpCaseStr(ParamStr(i)) = '-H') or
         (UpCaseStr(ParamStr(i)) = 'H') or
         (UpCaseStr(ParamStr(i)) = '/H') or
         (UpCaseStr(ParamStr(i)) = '/?') then begin
         WriteLn;
         WriteLn('TalkIt Simple Voice Talk Aloud Filter, options:');
         WriteLn('      talkit -v n {-q} {-h} < InFile > OutFile');
         WriteLn('         -t Trace');
         WriteLn('         -a Filter into 7 bits ASCII');
         WriteLn('         -v Voice Processor');
         WriteLn('         -h This Help');
         WriteLn;
         Halt;
      end; {endif}

      inc(i);
    end; {endwhile}

    If fQuiet = FALSE then begin
       WriteLn(PROGRAMNAME+' Version '+VERSION+'.'+PROGRAMBUILD+' '+AUTHOR);
    end; {endif}

    {*--------------------------------------------*}
    {*    Initialize COM Objects for MSXML3       *}
    {*--------------------------------------------*}
    CoInitialize(nil);
    hSpeech := TMSPeech.Create(Nil);

    {*--------------------------------------------*}
    {* Speech Processor Initialization            *}
    {*--------------------------------------------*}
    If fVoice = TRUE then begin

       If hSpeech.Engines.Count > 0 then begin
          If wVoice > hSpeech.Engines.Count then begin
             wVoice := 1;
          end; {endif}

          Try
            hSpeech.SelectEngine(hSpeech.Engines.Strings[wVoice]);
          Except
            WriteLn('TalkIt(001) ** Selected Speech Processor Not Available **');
            Halt;
          End;

       end else begin
          WriteLn('TalkIt(002) ** Speech Processor not available **');
          Halt;
       end; {endif}
    end; {endif}

    SetConsoleCtrlHandler(@ConProc, True);
    {*--------------------------------------------*}
    {*    Read the Input into a Stream            *}
    {*--------------------------------------------*}
    While not EOF(Input) do begin
      ReadLn(szBuffer);
      szBuffer := szBuffer + CR;
      hStream.Write(szBuffer[1],Length(szBuffer));
      If fTrace = TRUE then begin
         WriteLn(szBuffer);
      end; {endif}
    end; {endwhile}

    If fQuiet = FALSE then begin
       WriteLn('TalkIt(000): Buffer Completed Size('+IntToStr(hStream.Size)+' Bytes)');
    end; {endif}

    {*--------------------------------------------*}
    {*    Reset Stream and Load into a Buffer     *}
    {*--------------------------------------------*}
    hStream.Seek(0,0);

    {*--------------------------------------------*}
    {*    Just talkt it thru                      *}
    {*--------------------------------------------*}
    Try
      szBuffer := '';
      iLen := hStream.Read(pBuffer,1);
      While iLen > 0 do begin
        If pBuffer[0] = LF then begin
        end else begin
           If pBuffer[0] = CR then begin
              If fQuiet = FALSE then begin
                 WriteLn(szBuffer);
              end; {endif}
              szBuffer := szBuffer + NUL;
              hSpeech.Text.Clear;
              hSpeech.Text.Add(szBuffer);
              hSpeech.Speak;
              Application.ProcessMessages;
              While hSpeech.Speaking = TRUE do begin
                Application.ProcessMessages;
              end; {endwhile}
              szBuffer := '';
           end else begin
              If fASCII = TRUE then begin
                 If (Ord(pBuffer[0]) >= $20) and (Ord(pBuffer[0]) <= $7A) then begin
                    szBuffer := szBuffer + pBuffer[0];
                 end; {endif}
              end else begin
                 szBuffer := szBuffer + pBuffer[0];
              end; {endif}
           end; {endif}
        end; {endif}
        iLen := hStream.Read(pBuffer,1);
      end; {endwhile}
    Except
      WriteLn('TalkIt(003) ** Speech Processor Error **');
    End;

    {*--------------------------------------------*}
    {*    Present and Terminate                   *}
    {*--------------------------------------------*}
    hStream.Free;
    hSpeech.Destroy;
    Halt;

end. { TalkIt }
